# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _without_gcj_support 1
%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define _without_maven 1
%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define base_name       pool
%define short_name      commons-%{base_name}
%define section         free

%bcond_without repolib
%define repodir %{_javadir}/repository.jboss.com/apache-pool/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

Name:           jakarta-commons-pool
Version:        1.3
Release:        15%{?dist}
Epoch:          0
Summary:        Jakarta Commons Pool Package
License:        ASL 2.0
Group:          Development/Libraries/Java
Source0:	http://archive.apache.org/dist/commons/pool/source/commons-pool-1.3-src.tar.gz
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        %{base_name}-%{version}-jpp-depmap.xml
Source5:        commons-build.tar.gz
Source6:        pool-tomcat5-build.xml
Source7:        commons-pool-maven-build.dtd
Source8:        commons-pool-commons.ent
Source9:        http://mirrors.ibiblio.org/pub/mirrors/maven2/commons-pool/commons-pool/1.3/commons-pool-1.3.pom
Source10:        commons-pool-component-info.xml
Patch0:         jakarta-commons-pool-build.patch

URL:            http://jakarta.apache.org/commons/%{base_name}
BuildRequires:  ant 
BuildRequires:  junit
BuildRequires:  jpackage-utils > 0:1.6
BuildRequires:  java-javadoc
BuildRequires:  java-devel >= 1.5.0
BuildRequires:  maven-deploy-plugin
%if %{with_maven}
BuildRequires:  maven >= 0:1.1
BuildRequires:  maven-plugins-base
BuildRequires:  maven-plugin-test
BuildRequires:  maven-plugin-xdoc
BuildRequires:  maven-plugin-license
BuildRequires:  maven-plugin-changes
BuildRequires:  maven-plugin-jdepend
BuildRequires:  maven-plugin-jdiff
BuildRequires:  maven-plugin-jxr
BuildRequires:  maven-plugin-scm
BuildRequires:  maven-plugin-tasklist
BuildRequires:  saxon
BuildRequires:  saxon-scripts
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  xerces-j2
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
Provides:       %{short_name} = %{epoch}:%{version}-%{release} 
Obsoletes:      %{short_name} < %{epoch}:%{version}-%{release}

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
%endif

%description
The goal of Pool package it to create and maintain an object 
(instance) pooling package to be distributed under the ASF license.
The package should support a variety of pool implementations, but
encourage support of an interface that makes these implementations
interchangeable.

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation
Requires:       java-javadoc

%description javadoc
Javadoc for %{name}.

%package tomcat5
Summary:        Pool dependency for Tomcat5
Group:          Development/Libraries/Java

%description tomcat5
Pool dependency for Tomcat5


%if %{with_maven}
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
cat <<EOT

                If you dont want to build with maven,
                give rpmbuild option '--without maven'

EOT

rm -rf $RPM_BUILD_ROOT
%setup -q -n %{short_name}-%{version}-src
%setup -q -n %{short_name}-%{version}-src -D -T -a 5
# remove all binary libs
find . -name "*.jar" | xargs %{__rm}
%patch0 -p0
cp -p %{SOURCE6} .

%if %{with_maven}
#Hack to get around building completely offline
#TODO: properly setup xmlcatalog to properly point to local dtd and commons.ent
cp -p %{SOURCE7} maven-build.dtd
cp -p %{SOURCE8} commons.ent
sed -i 's_http://jakarta.apache.org/commons/build_'$(pwd)'_' maven-build.dtd
sed -i 's_http://jakarta.apache.org/commons/build_'$(pwd)'_' xdocs/navigation.xml
%endif

%build
mkdir ./tmp
%if %{with_maven}
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    %{_bindir}/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

maven \
        -Dmaven.javadoc.source=1.4 \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=$(pwd)/.maven \
         jar javadoc xdoc:transform
%else
ant -Djava.io.tmpdir=. clean dist
%endif
#commons-pool-tomcat5
ant -f pool-tomcat5-build.xml

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
%if %{with_maven}
install -m 644 target/%{short_name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%else
install -m 644 dist/%{short_name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%endif
#tomcat5 jar
install -m 644 pool-tomcat5/%{short_name}-tomcat5.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-tomcat5-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|jakarta-||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 %{SOURCE9} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{short_name}.pom
%add_to_maven_depmap %{short_name} %{short_name} %{version} JPP %{short_name}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %{with_maven}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf target/docs/apidocs
%else
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{with_maven}
# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{repodir}
%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=commons-pool -DartifactId=commons-pool -Dversion=%{version} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/%{name}-%{version}.jar -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-%{short_name}.pom -Durl=file://%{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE9} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH0} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{short_name}.pom %{buildroot}%{repodirlib}/%{short_name}.pom
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/%{short_name}.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post tomcat5
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun tomcat5
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc README.txt LICENSE.txt
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{short_name}.jar
%{_javadir}*/%{short_name}-%{version}.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files tomcat5
%defattr(0644,root,root,0755)
%{_javadir}*/*-tomcat5*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*-tomcat5*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %{with_maven}
%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Dec 23 2010 Hui Wang <huwang@redhat.com> - 0:1.3-15
- Add %%bcond_without repolib

* Thu Dec 23 2010 Hui Wang <huwang@redhat.com> - 0:1.3-14
- Add repolib subpackge

* Thu Dec 23 2010 Hui Wang <huwang@redhat.com> - 0:1.3-13
- Add repolib

* Thu Nov 18 2010 Hui Wang <huwang@redhat.com> - 0:1.3-12
- Fix %%files for signed jars
- Fix source0

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.3-11.2.1
- rebuilt

* Tue Apr 20 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.3-11.2
- Rebuild

* Wed Nov 26 2008 Permaine Cheung <pcheung@redhat.com> - 0:1.3-11.1
- Merge with upstream

* Fri Jun 27 2008 David Walluck <dwalluck@redhat.com> 0:1.3-11
- fix License
- remove Vendor and Distribution tags
- fix BuildRoot tag
- properly unpack sources
- remove javadoc scriptlets
- use macros
- add fixes to GCJ support

* Fri May 11 2007 Jason Corley <jason.corley@gmail.com> 0:1.3-10jpp
- rebuild through mock and centos 4
- replace vendor and distribution with macros

* Fri May 04 2007 Ralph Apel <r.apel at r-apel.de> 0:1.3-9jpp
- Add maven-plugin-scm BR
- Silence prep
- Fix dir for gcj_support
- Restore Vendor and Distribution
- Avoid empty post/postun
- Fix epoch in changelog

* Mon Mar 12 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.3-2jpp.ep1.1
- Rebuild with maven noarch
- Add missing BR for maven plug-ins

* Tue Aug 01 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.3-2jpp_1rh
- Merge with upstream

* Thu Jul 20 2006 Deepak Bhole <dbhole@redhat.com> - 0:1.3-2jpp
- Added conditional native compilation.

* Wed Apr 12 2006 Randy Watler <rwatler at finali.com> - 0:1.3-1jpp
- Upgrade to 1.3
- First JPP-1.7 release
- Build with maven by default
- Add option to build with straight ant
- Add -manual subpackage when built with maven
- This version doesn't require commons-collections

* Tue Nov 23 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.2-2jpp_1rh
- Merge with upstream for upgrade

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.2-2jpp
- Rebuild with ant-1.6.2

* Thu Jun 24 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:1.2-1jpp
- Update to 1.2 (tomcat 5.0.27 wants it)

* Thu Mar  4 2004 Frank Ch. Eigler <fche@redhat.com> 0:1.1-1jpp_1rh
- RH vacuuming

* Mon Oct 27 2003 Henri Gomez <hgomez@users.sourceforge.net>  0:1.1-1jpp
- commons-pool 1.1

* Fri May 09 2003 David Walluck <david@anti-microsoft.org> 0:1.0.1-5jpp
- update for JPackage 1.5

* Tue Mar 25 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.0.1-4jpp
- For jpackage-utils 1.5

* Thu Feb 27 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.0.1-3jpp
- fix ASF license

* Thu Feb 27 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.0.1-2jpp
- fix missing packager tag

* Fri Aug 23 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0.1-1jpp
- 1.0.1

* Fri Jul 12 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0-3jpp
- override java.io.tmpdir to avoid build use /tmp

* Mon Jun 10 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0-2jpp
- use sed instead of bash 2.x extension in link area to make spec compatible
  with distro using bash 1.1x

* Fri Jun 07 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0-1jpp 
- 1.0
- added short names in %{_javadir}, as does jakarta developpers
- first jPackage release
